mod utils;
mod solutions;

use std::error::Error;

use solutions::{dayxx::Solution, *};

use crate::utils::get_input;

fn main() -> Result<(), Box<dyn Error>>{

    let days: Vec<Box<dyn Solution>> = vec![
        Box::new(day01::Day01{}),
        Box::new(day02::Day02{})
    ];

    for day in days {
        println!("Day{} Part1 Test: {}", day.get_day(), day.part1(get_input(day.get_day(), utils::InputType::Test1)?.as_mut())?);
        println!("Day{} Part1 Result: {}", day.get_day(), day.part1(get_input(day.get_day(), utils::InputType::Actual)?.as_mut())?);

        println!("Day{} Part2 Test: {}", day.get_day(), day.part2(get_input(day.get_day(), utils::InputType::Test2)?.as_mut())?);
        println!("Day{} Part2 Result: {}", day.get_day(), day.part2(get_input(day.get_day(), utils::InputType::Actual)?.as_mut())?);
    }

    Ok(())
}
