use std::{
    error::Error,
    fs::File,
    io::{prelude::*, BufReader},
};

/// Enum used to specify input
pub enum InputType {
    Test1,
    Test2,
    Actual,
}

/// Function to get the input for a given day of AoC
pub fn get_input(day: u8, input: InputType) -> Result<Vec<String>, Box<dyn Error>> {
    // Find Input File Name
    let file_name = match input {
        InputType::Test1 => format!("src/input/day{:02}_test1", day),
        InputType::Test2 => format!("src/input/day{:02}_test2", day),
        InputType::Actual => format!("src/input/day{:02}", day),
    };

    // Read file into buffer
    let file = File::open(file_name)?;
    let reader = BufReader::new(file);

    // Convert itterate buffer and return string vec
    let data = reader
        .lines()
        .map(|s| s.unwrap_or(String::from("")))
        .collect();

    Ok(data)
}
